<?php
/*
	osCommerce, Open Source E-Commerce Solutions 
	http://www.oscommerce.com 
	
	Copyright (c) 2003 osCommerce 
	
	osCommRes, Services Oline 
	http://www.oscommres.com 
	Copyright (c) 2005 osCommRes 
	
	Freeway eCommerce 
	http://www.zac-ware.com/freeway 
	Copyright (c) 2007 ZacWare 
	
	Released under the GNU General Public License
*/
  function tep_href_link($page = '', $parameters = '', $connection = 'NONSSL', $add_session_id = true, $search_engine_safe = true) {
    global $request_type, $session_started, $SID,$joomla_include,$HTTP_GET_VARS,$freeway_path_after_joomla,$navigation,$openfile,$req_url,$SEF_ON,$HTTP_GET_VARS;    
	if($joomla_include){
		$tmp_page_name=$page;
		$tmp_parameters=$parameters;		
		$joomla_seo_config =& JFactory::getConfig();
		$joomla_seo = $joomla_seo_config->getValue('config.sef');
		$joomla_rewrite = $joomla_seo_config->getValue('config.sef_rewrite');
 		if(($joomla_seo==0 || $joomla_rewrite==0) && $search_engine_safe==true) $search_engine_safe=false; 		 	
 		if(strpos(",".$parameters,'option=com_freeway')!==false || strpos(",".$parameters,'openfile=')!==false || strpos(",".$parameters,'component=freeway')!==false){ 		 	
 		 	$parameters=str_replace(array("option=com_freeway&openfile=","component=freeway&openfile","option=com_freeway","component=freeway"),"",$parameters);
 		 	$rep_str=substr($parameters,0,strpos($parameters,"&"));
 		 	$parameters=str_replace($rep_str,"",$parameters);
 		}
 		$joomla_login_params="";
 		if($page!='index.php' || ($page=='index.php' && $parameters!='')) {
 			$sef_url_array = array(FILENAME_DEFAULT=>true, FILENAME_PRODUCT_INFO=>true,FILENAME_EVENTS_MONTH_VIEW=>true,FILENAME_EVENTS_WEEK_VIEW=>true,FILENAME_EVENTS_DAY_VIEW=>true,FILENAME_SUBSCRIPTION_INFO=>true,FILENAME_SERVICES_INFO=>true,FILENAME_SESSION_DETAILS=>true);			
			if($GLOBALS["SEO_URL"]->enabled && $search_engine_safe == true && strpos(",".$parameters,"openfile")===false)	{
				$sef_content_start=strpos(",".$parameters,"products=");
				if(strpos(",".$parameters,"events=")!==false) $sef_content_start=strpos(",".$parameters,"events=");
				else if(strpos(",".$parameters,"subscriptions=")!==false) $sef_content_start=strpos(",".$parameters,"subscriptions=");
				else if(strpos(",".$parameters,"services=")!==false) $sef_content_start=strpos(",".$parameters,"services=");
				if($sef_content_start>0) {
					$rep_str=substr($parameters,0,strpos(substr(",".$parameters,$sef_content_start),"&")+$sef_content_start);
					$parameters=str_replace($rep_str,"",$parameters);	
				}
				if(!$sef_url_array[$page]) $parameters="component/freeway/openfile=".base64_encode($page).'&'.$parameters;				
				else $parameters="component/freeway/".$parameters;
			}else $parameters="option=com_freeway&openfile=".base64_encode($page).'&'.$parameters;
 		} 		
 		$return_url="";
 		$uri = JFactory::getURI();
	 	$raw_url = $uri->toString();	 		 
 		if($joomla_seo==1 && $joomla_rewrite==1)  $return_url='/component/freeway';
 		if($page==FILENAME_LOGIN){			
			$parameters="option=com_user&view=login&return=".base64_encode($raw_url.$return_url);
		 	$joomla_login_params=$parameters;
 		}  		
	 	$page="link_index.php";
	 	if($GLOBALS["SEO_URL"]->enabled && $joomla_seo==1 && $search_engine_safe==true && ($joomla_rewrite==1 || $joomla_login_params)) $page="index.php";	 	
	}   
    if (!tep_not_null($page)) {
      die('</td></tr></table></td></tr></table><br><br><font color="#ff0000"><b>Error!</b></font><br><br><b>Unable to determine the page link!<br><br>');
    }
    if ($parameters!='') $parameters=trim($parameters,"/");
	if(strpos($parameters,'command=')!==false && !$search_engine_safe)
		$connection=$request_type;
    if ($connection == 'NONSSL') {
      $link = HTTP_SERVER . DIR_WS_HTTP_CATALOG;
    } elseif ($connection == 'SSL') {
      if (ENABLE_SSL == 'true') {
        $link = HTTPS_SERVER . DIR_WS_HTTPS_CATALOG;
      } else {
        $link = HTTP_SERVER . DIR_WS_HTTP_CATALOG;
      }
    } else {
      die('</td></tr></table></td></tr></table><br><br><font color="#ff0000"><b>Error!</b></font><br><br><b>Unable to determine connection method on a link!<br><br>Known methods: NONSSL SSL</b><br><br>');
    }
	$root_path_url=$link;
    if (tep_not_null($parameters)) {
      $link .= $page . '?' . tep_output_string($parameters);
      $separator = '&';
    } else {
      $link .= $page;
      $separator = '?';
    }

    while ( (substr($link, -1) == '&') || (substr($link, -1) == '?') ) $link = substr($link, 0, -1);

// Add the session ID when moving from different HTTP and HTTPS servers, or when SID is defined
    if ( ($add_session_id == true) && ($session_started == true) && (SESSION_FORCE_COOKIE_USE == 'False') ) {
      if (tep_not_null($SID)) {
        $_sid = $SID;
      } elseif ( ( ($request_type == 'NONSSL') && ($connection == 'SSL') && (ENABLE_SSL == true) ) || ( ($request_type == 'SSL') && ($connection == 'NONSSL') ) ) {
        if (HTTP_COOKIE_DOMAIN != HTTPS_COOKIE_DOMAIN) {
          $_sid = tep_session_name() . '=' . tep_session_id();
        }
      }
    }
	$tmp_url=$link;
	if ($GLOBALS["SEO_URL"]->enabled && $search_engine_safe == true){
      while (strstr($link, '&&')) $link = str_replace('&&', '&', $link);

      $link = str_replace('?', '/', $link);
      $link = str_replace('&', '/', $link);
      $link = str_replace('=', '/', $link);

      $separator = '?';
      $link = $GLOBALS["SEO_URL"]->convert_seo_url($link);
	}
    if (isset($_sid)) {
	  $link .= $separator . tep_output_string($_sid);
    }
    if(isset($joomla_include) && $joomla_include) {		    	
		if($joomla_login_params!="") {
			$link=$page.'?'.$joomla_login_params;
		}
		$url=str_replace(array('.html','&&','\\','index.php/'),array('','&','/',''),JRoute::_($link,false));
		$url=substr($url,0,strpos($url,"://")+3).str_replace("//","/",substr($url,strpos($url,"://")+3));
		$com_replace=strlen('option/com_freeway/');
		if($com_replace==""){
			$com_replace=strlen('component/freeway/');
		}
		//if($GLOBALS["SEO_URL"]->enabled && $search_engine_safe == true && $sef_url_array[$page]==true && strpos(",".$url,"openfile")===false && (strpos(",".$url,"products/")!==false || strpos(",".$url,"events/")!==false || strpos(",".$url,"subscriptions/")!==false || strpos(",".$url,"services/")!==false) && strlen(substr($url,strpos(",".$url,"/ex/")+4+$com_replace))==0){
		if($GLOBALS["SEO_URL"]->enabled && $search_engine_safe == true && $sef_url_array[$page]==true && strpos(",".$url,"openfile")===false && (strpos(",".$url,"products/")!==false || strpos(",".$url,"events/")!==false || strpos(",".$url,"subscriptions/")!==false || strpos(",".$url,"services/")!==false)){
			$url=str_replace(array('/ex/option/com_freeway','/ex/component/freeway'),"",$url);
		}
		return $url;
    }else return $link;
  }

////
// The HTML image wrapper function
  function tep_image($src, $alt = '', $width = '', $height = '', $parameters = '') {
    if ( (empty($src) || ($src == DIR_WS_IMAGES)) && (IMAGE_REQUIRED == 'false') ) {
      return false;
    }

// alt is added to the img tag even if it is null to prevent browsers from outputting
// the image filename as default
    $image = '<img src="' . tep_output_string($src) . '" border="0" alt="' . tep_output_string($alt) . '"';

    if (tep_not_null($alt)) {
      $image .= ' title=" ' . tep_output_string($alt) . ' "';
    }

    if ( (CONFIG_CALCULATE_IMAGE_SIZE == 'true') && (empty($width) || empty($height)) ) {
      if ($image_size = @getimagesize($src)) {
        if (empty($width) && tep_not_null($height)) {
          $ratio = $height / $image_size[1];
          $width = intval($image_size[0] * $ratio);
        } elseif (tep_not_null($width) && empty($height)) {
          $ratio = $width / $image_size[0];
          $height = intval($image_size[1] * $ratio);
        } elseif (empty($width) && empty($height)) {
          $width = $image_size[0];
          $height = $image_size[1];
        }
      } elseif (IMAGE_REQUIRED == 'false') {
        return false;
      }
    }

    if (tep_not_null($width) && tep_not_null($height)) {
      $image .= ' width="' . tep_output_string($width) . '" height="' . tep_output_string($height) . '"';
    }

    if (tep_not_null($parameters)) $image .= ' ' . $parameters;

    $image .= '>';

    return $image;
  }

////
// The HTML form submit button wrapper function
// Outputs a button in the selected language
  function tep_image_submit($image, $alt = '', $parameters = '') {
    global $language;

    $image_submit = '<input style="border:none" type="image" src="' . tep_output_string(DIR_WS_LANGUAGES . $language . '/images/buttons/' . $image) . '" border="0" alt="' . tep_output_string($alt) . '"';

    if (tep_not_null($alt)) $image_submit .= ' title=" ' . tep_output_string($alt) . ' "';

    if (tep_not_null($parameters)) $image_submit .= ' ' . $parameters;

    $image_submit .= '>';

    return $image_submit;
  }

////
// Output a function button in the selected language
  function tep_image_button($image, $alt = '', $parameters = '') {
    global $language;

    return tep_image(DIR_WS_LANGUAGES . $language . '/images/buttons/' . $image, $alt, '', '', $parameters);
  }

////
// Output a separator either through whitespace, or with an image
  function tep_draw_separator($image = 'pixel_black.gif', $width = '100%', $height = '1') {
    return tep_image(DIR_WS_HTTP_CATALOG.DIR_WS_IMAGES . $image, '', $width, $height);
  }

////
// Output a form
  function tep_draw_form($name, $action, $method = 'post', $parameters = '') {
  	global $HTTP_SESSION_VARS;
    $form = '<form name="' . tep_output_string($name) . '" action="' . tep_output_string($action) . '" method="' . tep_output_string($method) . '"';

    if (tep_not_null($parameters)) $form .= ' ' . $parameters;

    $form .= '>';
	if(!tep_session_is_registered('customer_id'))
		$HTTP_SESSION_VARS['freeway'] = md5('freeway');

    return $form;
  }

////
// Output a form input field
  function tep_draw_input_field($name, $value = '', $parameters = '', $type = 'text', $reinsert_value = true) {
    $field = '<input type="' . tep_output_string($type) . '" name="' . tep_output_string($name) . '"';

    if ( (isset($GLOBALS[$name])) && ($reinsert_value == true) ) {
      $field .= ' value="' . tep_output_string(stripslashes($GLOBALS[$name])) . '"';
    } elseif (tep_not_null($value)) {
      $field .= ' value="' . tep_output_string($value) . '"';
    }

    if (tep_not_null($parameters)) $field .= ' ' . $parameters;

    $field .= '>';

    return $field;
  }

////
// Output a form password field
  function tep_draw_password_field($name, $value = '', $parameters = 'maxlength="40"') {
    return tep_draw_input_field($name, $value, $parameters, 'password', false);
  }

////
// Output a selection field - alias function for tep_draw_checkbox_field() and tep_draw_radio_field()
  function tep_draw_selection_field($name, $type, $value = '', $checked = false, $parameters = '') {
    $selection = '<input style="border:none;background:none" type="' . tep_output_string($type) . '" name="' . tep_output_string($name) . '"';

    if (tep_not_null($value)) $selection .= ' value="' . tep_output_string($value) . '"';

    if ( ($checked == true) || ( isset($GLOBALS[$name]) && is_string($GLOBALS[$name]) && ( ($GLOBALS[$name] == 'on') || (isset($value) && (stripslashes($GLOBALS[$name]) == $value)) ) ) ) {
      $selection .= ' CHECKED';
    }

    if (tep_not_null($parameters)) $selection .= ' ' . $parameters;

    $selection .= '>';

    return $selection;
  }

////
// Output a form checkbox field
  function tep_draw_checkbox_field($name, $value = '', $checked = false, $parameters = '') {
    return tep_draw_selection_field($name, 'checkbox', $value, $checked, $parameters);
  }

////
// Output a form radio field
  function tep_draw_radio_field($name, $value = '', $checked = false, $parameters = '') {
    return tep_draw_selection_field($name, 'radio', $value, $checked, $parameters);
  }

////
// Output a form textarea field
  function tep_draw_textarea_field($name, $wrap, $width, $height, $text = '', $parameters = '', $reinsert_value = true) {
    $field = '<textarea name="' . tep_output_string($name) . '" wrap="' . tep_output_string($wrap) . '" cols="' . tep_output_string($width) . '" rows="' . tep_output_string($height) . '"';

    if (tep_not_null($parameters)) $field .= ' ' . $parameters;

    $field .= '>';

    if ( (isset($GLOBALS[$name])) && ($reinsert_value == true) ) {
  		$field .= tep_output_string_protected(stripslashes($GLOBALS[$name]));
	  } elseif (tep_not_null($text)) {
		$field .= tep_output_string_protected($text);
      }

$field .= '</textarea>';

    return $field;
  }

////
// Output a form hidden field
  function tep_draw_hidden_field($name, $value = '', $parameters = '') {
    $field = '<input type="hidden" name="' . tep_output_string($name) . '"';

    if (tep_not_null($value)) {
      $field .= ' value="' . tep_output_string($value) . '"';
    } elseif (isset($GLOBALS[$name])) {
      $field .= ' value="' . tep_output_string(stripslashes($GLOBALS[$name])) . '"';
    }

    if (tep_not_null($parameters)) $field .= ' ' . $parameters;

    $field .= '>';

    return $field;
  }

////
// Hide form elements
  function tep_hide_session_id() {
    global $session_started, $SID;

    if (($session_started == true) && tep_not_null($SID)) {
      return tep_draw_hidden_field(tep_session_name(), tep_session_id());
    }
  }

////
// Output a form pull down menu
  function tep_draw_pull_down_menu($name, $values, $default = '', $parameters = '', $required = false) {      

    $field = '<select name="' . tep_output_string($name) . '"';

    if (tep_not_null($parameters)) $field .= ' ' . $parameters;

    $field .= '>';

    if (empty($default) && isset($GLOBALS[$name])) $default = stripslashes($GLOBALS[$name]);

    for ($i=0, $n=sizeof($values); $i<$n; $i++) {
      $field .= '<option value="' . tep_output_string($values[$i]['id']) . '"';
      if ($default == $values[$i]['id']) {
        $field .= ' SELECTED';
      }

      $field .= '>' . tep_output_string($values[$i]['text'], array('"' => '&quot;', '\'' => '&#039;', '<' => '&lt;', '>' => '&gt;')) . '</option>'; 
    }
    $field .= '</select>';
    if ($required == true) $field .= TEXT_FIELD_REQUIRED;
    return $field;
  }

////
// Creates a pull-down list of countries
  function tep_get_country_list($name, $selected = '', $parameters = '') {
    $countries_array = array(array('id' => '', 'text' => PULL_DOWN_DEFAULT));
    $countries = tep_get_countries();

    for ($i=0, $n=sizeof($countries); $i<$n; $i++) {
      $countries_array[] = array('id' => $countries[$i]['countries_id'], 'text' => $countries[$i]['countries_name']);
    }

    return tep_draw_pull_down_menu($name, $countries_array, $selected, $parameters);
  }
  function tep_load_template_content($filename){
  	 $file_path=DIR_FS_CATALOG . DIR_WS_TEMPLATES . TEMPLATE_NAME . "/content/" . $filename;
	 $require_path=DIR_WS_TEMPLATES . TEMPLATE_NAME . "/content/" . $filename;
	 if (!file_exists($file_path)) return "";
  	 $content=@file_get_contents($file_path);
	 if ($content==""){
	 	ob_start();
		require(CHECK_CON . $require_path);
		$content=ob_get_contents();
		ob_end_clean();
	 }
	 return $content;
  }
?>
